#target photoshop

app.bringToFront();
var fldrPth = "~/Desktop/CrystDial/";
var fldr = new Folder(fldrPth);
fldr.create();

var startRulerUnits = app.preferences.rulerUnits;
var startTypeUnits = app.preferences.typeUnits; 
var startDisplayDialogs = app.displayDialogs; 
var lyr1 = new Array(64);
var lyr2 = new Array(64);
var lyr3 = new Array(64);
var lyr4 = new Array(64);
var lyrmask = new Array(64);

main();

function main() {

// Set Adobe Photoshop CS3 to use pixels and display no dialogs 
app.preferences.rulerUnits = Units.PIXELS;
app.preferences.typeUnits = TypeUnits.PIXELS;
app.displayDialogs = DialogModes.NO;

var dcmnt = app.documents.add(3200, 100, 72, "CrystalDial", NewDocumentMode.RGB, DocumentFill.WHITE);

dcmnt.bitsPerChannel = BitsPerChannelType.EIGHT;
dcmnt.layers[0].name = "background";

for(i=20; i<340; i=i+5)
{

var icalc = i - 20;
var iclc = icalc/5;
var docWidth = dcmnt.width.value;
var docHeight = dcmnt.height.value;
var centerX = (((dcmnt.width.value / 64) * iclc) + 25);

var x, y, w, h = 0;

	x = centerX - 25;
	w = centerX + 25;
	y = 0;
	h = 50;

lyr1[iclc] = dcmnt.artLayers.add();
lyr1[iclc].name = "One" + iclc;

circularSelection(x, y, w, h);
var fill1 = new RGBColor();
var mskFill = new RGBColor();
mskFill.hexValue = "000000";
var mskFill2 = new RGBColor();
mskFill2.hexValue = "FFFFFF";
var hndFill = new RGBColor();
hndFill.hexValue = "000011";
var hndFill2 = new RGBColor();
hndFill2.hexValue = "770011";
fill1.hexValue = "444444";
dcmnt.selection.fill(fill1);

lyrmask[iclc] = dcmnt.artLayers.add();
lyrmask[iclc].name = "Mask" + iclc;
dcmnt.selection.translateBoundary(0, 50);
dcmnt.selection.fill(mskFill);
dcmnt.selection.translateBoundary(0, -50);

dcmnt.selection.contract(7);
dcmnt.selection.clear();
dcmnt.selection.expand(6);
dcmnt.selection.feather(3);

lyr2[iclc] = dcmnt.artLayers.add();
lyr2[iclc].name = "Two" + iclc;

var fill2 = new RGBColor();
fill2.hexValue = "665A66";
dcmnt.selection.fill(fill2);
dcmnt.selection.contract(6);
dcmnt.selection.clear();
lyr2.opacity = 56;

dcmnt.selection.expand(5);
dcmnt.selection.feather(2);

lyr3[iclc] = dcmnt.artLayers.add();
lyr3[iclc].name = "Three" + iclc;

var fill3 = new RGBColor();     
fill3.hexValue = "774444";
dcmnt.selection.fill(fill3, ColorBlendMode.NORMAL, 28);
dcmnt.selection.contract(4);
dcmnt.selection.feather(0);
dcmnt.selection.clear();

lyr4[iclc] = dcmnt.artLayers.add();
lyr4[iclc].name = "Four" + iclc;
dcmnt.activeLayer.blendMode = BlendMode.LINEARDODGE;
var fill4 = new RGBColor();
fill4.hexValue = "776633";
dcmnt.selection.fill(fill4, ColorBlendMode.OVERLAY, 80);




/* ------ borrowed from ScriptListener to achieve gradient fill ------ */
var id18 = charIDToTypeID( "Grdn" );
    var desc3 = new ActionDescriptor();
    var id19 = charIDToTypeID( "From" );
        var desc4 = new ActionDescriptor();
        var id20 = charIDToTypeID( "Hrzn" );
        var id21 = charIDToTypeID( "#Pxl" );
        desc4.putUnitDouble( id20, id21, 36.000000 );
        var id22 = charIDToTypeID( "Vrtc" );
        var id23 = charIDToTypeID( "#Pxl" );
        desc4.putUnitDouble( id22, id23, 2.000000 );
    var id24 = charIDToTypeID( "Pnt " );
    desc3.putObject( id19, id24, desc4 );
    var id25 = charIDToTypeID( "T   " );
        var desc5 = new ActionDescriptor();
        var id26 = charIDToTypeID( "Hrzn" );
        var id27 = charIDToTypeID( "#Pxl" );
        desc5.putUnitDouble( id26, id27, 36.000000 );
        var id28 = charIDToTypeID( "Vrtc" );
        var id29 = charIDToTypeID( "#Pxl" );
        desc5.putUnitDouble( id28, id29, 72.000000 );
    var id30 = charIDToTypeID( "Pnt " );
    desc3.putObject( id25, id30, desc5 );
    var id31 = charIDToTypeID( "Type" );
    var id32 = charIDToTypeID( "GrdT" );
    var id33 = charIDToTypeID( "Lnr " );
    desc3.putEnumerated( id31, id32, id33 );
    var id34 = charIDToTypeID( "Dthr" );
    desc3.putBoolean( id34, true );
    var id35 = charIDToTypeID( "UsMs" );
    desc3.putBoolean( id35, true );
    var id36 = charIDToTypeID( "Grad" );
        var desc6 = new ActionDescriptor();
        var id37 = charIDToTypeID( "Nm  " );
        desc6.putString( id37, "Custom" );
        var id38 = charIDToTypeID( "GrdF" );
        var id39 = charIDToTypeID( "GrdF" );
        var id40 = charIDToTypeID( "CstS" );
        desc6.putEnumerated( id38, id39, id40 );
        var id41 = charIDToTypeID( "Intr" );
        desc6.putDouble( id41, 4096.000000 );
        var id42 = charIDToTypeID( "Clrs" );
            var list1 = new ActionList();
                var desc7 = new ActionDescriptor();
                var id43 = charIDToTypeID( "Clr " );
                    var desc8 = new ActionDescriptor();
                    var id44 = charIDToTypeID( "Rd  " );
                    desc8.putDouble( id44, 240.000000 );
                    var id45 = charIDToTypeID( "Grn " );
                    desc8.putDouble( id45, 100.000000 );
                    var id46 = charIDToTypeID( "Bl  " );
                    desc8.putDouble( id46, 0.000000 );
                var id47 = charIDToTypeID( "RGBC" );
                desc7.putObject( id43, id47, desc8 );
                var id48 = charIDToTypeID( "Type" );
                var id49 = charIDToTypeID( "Clry" );
                var id50 = charIDToTypeID( "UsrS" );
                desc7.putEnumerated( id48, id49, id50 );
                var id51 = charIDToTypeID( "Lctn" );
                desc7.putInteger( id51, 0 );
                var id52 = charIDToTypeID( "Mdpn" );
                desc7.putInteger( id52, 50 );
            var id53 = charIDToTypeID( "Clrt" );
            list1.putObject( id53, desc7 );
                var desc9 = new ActionDescriptor();
                var id54 = charIDToTypeID( "Clr " );
                    var desc10 = new ActionDescriptor();
                    var id55 = charIDToTypeID( "Rd  " );
                    desc10.putDouble( id55, 20.000001 );
                    var id56 = charIDToTypeID( "Grn " );
                    desc10.putDouble( id56, 40.000000 );
                    var id57 = charIDToTypeID( "Bl  " );
                    desc10.putDouble( id57, 240.000000 );
                var id58 = charIDToTypeID( "RGBC" );
                desc9.putObject( id54, id58, desc10 );
                var id59 = charIDToTypeID( "Type" );
                var id60 = charIDToTypeID( "Clry" );
                var id61 = charIDToTypeID( "UsrS" );
                desc9.putEnumerated( id59, id60, id61 );
                var id62 = charIDToTypeID( "Lctn" );
                desc9.putInteger( id62, 4096 );
                var id63 = charIDToTypeID( "Mdpn" );
                desc9.putInteger( id63, 50 );
            var id64 = charIDToTypeID( "Clrt" );
            list1.putObject( id64, desc9 );
        desc6.putList( id42, list1 );
        var id65 = charIDToTypeID( "Trns" );
            var list2 = new ActionList();
                var desc11 = new ActionDescriptor();
                var id66 = charIDToTypeID( "Opct" );
                var id67 = charIDToTypeID( "#Prc" );
                desc11.putUnitDouble( id66, id67, 100.000000 );
                var id68 = charIDToTypeID( "Lctn" );
                desc11.putInteger( id68, 0 );
                var id69 = charIDToTypeID( "Mdpn" );
                desc11.putInteger( id69, 50 );
            var id70 = charIDToTypeID( "TrnS" );
            list2.putObject( id70, desc11 );
                var desc12 = new ActionDescriptor();
                var id71 = charIDToTypeID( "Opct" );
                var id72 = charIDToTypeID( "#Prc" );
                desc12.putUnitDouble( id71, id72, 0.000000 );
                var id73 = charIDToTypeID( "Lctn" );
                desc12.putInteger( id73, 4096 );
                var id74 = charIDToTypeID( "Mdpn" );
                desc12.putInteger( id74, 50 );
            var id75 = charIDToTypeID( "TrnS" );
            list2.putObject( id75, desc12 );
        desc6.putList( id65, list2 );
    var id76 = charIDToTypeID( "Grdn" );
    desc3.putObject( id36, id76, desc6 );
executeAction( id18, desc3, DialogModes.NO );




/* ------ borrowed from ScriptListener to achieve inner glow and shadow ------ */
	var id5 = charIDToTypeID( "setd" );
    var desc2 = new ActionDescriptor();
    var id6 = charIDToTypeID( "null" );
        var ref2 = new ActionReference();
        var id7 = charIDToTypeID( "Prpr" );
        var id8 = charIDToTypeID( "Lefx" );
        ref2.putProperty( id7, id8 );
        var id9 = charIDToTypeID( "Lyr " );
        var id10 = charIDToTypeID( "Ordn" );
        var id11 = charIDToTypeID( "Trgt" );
        ref2.putEnumerated( id9, id10, id11 );
    desc2.putReference( id6, ref2 );
    var id12 = charIDToTypeID( "T   " );
        var desc3 = new ActionDescriptor();
        var id13 = charIDToTypeID( "Scl " );
        var id14 = charIDToTypeID( "#Prc" );
        desc3.putUnitDouble( id13, id14, 100.000000 );
        var id15 = charIDToTypeID( "IrSh" );
            var desc4 = new ActionDescriptor();
            var id16 = charIDToTypeID( "enab" );
            desc4.putBoolean( id16, true );
            var id17 = charIDToTypeID( "Md  " );
            var id18 = charIDToTypeID( "BlnM" );
            var id19 = charIDToTypeID( "Mltp" );
            desc4.putEnumerated( id17, id18, id19 );
            var id20 = charIDToTypeID( "Clr " );
                var desc5 = new ActionDescriptor();
                var id21 = charIDToTypeID( "Rd  " );
                desc5.putDouble( id21, 0.000000 );
                var id22 = charIDToTypeID( "Grn " );
                desc5.putDouble( id22, 0.000000 );
                var id23 = charIDToTypeID( "Bl  " );
                desc5.putDouble( id23, 0.000000 );
            var id24 = charIDToTypeID( "RGBC" );
            desc4.putObject( id20, id24, desc5 );
            var id25 = charIDToTypeID( "Opct" );
            var id26 = charIDToTypeID( "#Prc" );
            desc4.putUnitDouble( id25, id26, 100.000000 );
            var id27 = charIDToTypeID( "uglg" );
            desc4.putBoolean( id27, true );
            var id28 = charIDToTypeID( "lagl" );
            var id29 = charIDToTypeID( "#Ang" );
            desc4.putUnitDouble( id28, id29, 120.000000 );
            var id30 = charIDToTypeID( "Dstn" );
            var id31 = charIDToTypeID( "#Pxl" );
            desc4.putUnitDouble( id30, id31, 2.000000 );
            var id32 = charIDToTypeID( "Ckmt" );
            var id33 = charIDToTypeID( "#Pxl" );
            desc4.putUnitDouble( id32, id33, 0.000000 );
            var id34 = charIDToTypeID( "blur" );
            var id35 = charIDToTypeID( "#Pxl" );
            desc4.putUnitDouble( id34, id35, 0.000000 );
            var id36 = charIDToTypeID( "Nose" );
            var id37 = charIDToTypeID( "#Prc" );
            desc4.putUnitDouble( id36, id37, 0.000000 );
            var id38 = charIDToTypeID( "AntA" );
            desc4.putBoolean( id38, false );
            var id39 = charIDToTypeID( "TrnS" );
                var desc6 = new ActionDescriptor();
                var id40 = charIDToTypeID( "Nm  " );
                desc6.putString( id40, "Linear" );
            var id41 = charIDToTypeID( "ShpC" );
            desc4.putObject( id39, id41, desc6 );
        var id42 = charIDToTypeID( "IrSh" );
        desc3.putObject( id15, id42, desc4 );
        var id43 = charIDToTypeID( "IrGl" );
            var desc7 = new ActionDescriptor();
            var id44 = charIDToTypeID( "enab" );
            desc7.putBoolean( id44, true );
            var id45 = charIDToTypeID( "Md  " );
            var id46 = charIDToTypeID( "BlnM" );
            var id47 = charIDToTypeID( "Mltp" );
            desc7.putEnumerated( id45, id46, id47 );
            var id48 = charIDToTypeID( "Clr " );
                var desc8 = new ActionDescriptor();
                var id49 = charIDToTypeID( "Rd  " );
                desc8.putDouble( id49, 255.000000 );
                var id50 = charIDToTypeID( "Grn " );
                desc8.putDouble( id50, 255.000000 );
                var id51 = charIDToTypeID( "Bl  " );
                desc8.putDouble( id51, 189.997101 );
            var id52 = charIDToTypeID( "RGBC" );
            desc7.putObject( id48, id52, desc8 );
            var id53 = charIDToTypeID( "Opct" );
            var id54 = charIDToTypeID( "#Prc" );
            desc7.putUnitDouble( id53, id54, 100.000000 );
            var id55 = charIDToTypeID( "GlwT" );
            var id56 = charIDToTypeID( "BETE" );
            var id57 = charIDToTypeID( "PrBL" );
            desc7.putEnumerated( id55, id56, id57 );
            var id58 = charIDToTypeID( "Ckmt" );
            var id59 = charIDToTypeID( "#Pxl" );
            desc7.putUnitDouble( id58, id59, 0.000000 );
            var id60 = charIDToTypeID( "blur" );
            var id61 = charIDToTypeID( "#Pxl" );
            desc7.putUnitDouble( id60, id61, 0.000000 );
            var id62 = charIDToTypeID( "ShdN" );
            var id63 = charIDToTypeID( "#Prc" );
            desc7.putUnitDouble( id62, id63, 0.000000 );
            var id64 = charIDToTypeID( "Nose" );
            var id65 = charIDToTypeID( "#Prc" );
            desc7.putUnitDouble( id64, id65, 0.000000 );
            var id66 = charIDToTypeID( "AntA" );
            desc7.putBoolean( id66, false );
            var id67 = charIDToTypeID( "glwS" );
            var id68 = charIDToTypeID( "IGSr" );
            var id69 = charIDToTypeID( "SrcE" );
            desc7.putEnumerated( id67, id68, id69 );
            var id70 = charIDToTypeID( "TrnS" );
                var desc9 = new ActionDescriptor();
                var id71 = charIDToTypeID( "Nm  " );
                desc9.putString( id71, "Sawtooth 1" );
            var id72 = charIDToTypeID( "ShpC" );
            desc7.putObject( id70, id72, desc9 );
            var id73 = charIDToTypeID( "Inpr" );
            var id74 = charIDToTypeID( "#Prc" );
            desc7.putUnitDouble( id73, id74, 50.000000 );
        var id75 = charIDToTypeID( "IrGl" );
        desc3.putObject( id43, id75, desc7 );
    var id76 = charIDToTypeID( "Lefx" );
    desc2.putObject( id12, id76, desc3 );
executeAction( id5, desc2, DialogModes.NO );




// =======================================================
var id1 = charIDToTypeID( "setd" );
    var desc1 = new ActionDescriptor();
    var id2 = charIDToTypeID( "null" );
        var ref1 = new ActionReference();
        var id3 = charIDToTypeID( "Chnl" );
        var id4 = charIDToTypeID( "fsel" );
        ref1.putProperty( id3, id4 );
    desc1.putReference( id2, ref1 );
    var id5 = charIDToTypeID( "T   " );
    var id6 = charIDToTypeID( "Ordn" );
    var id7 = charIDToTypeID( "None" );
    desc1.putEnumerated( id5, id6, id7 );
executeAction( id1, desc1, DialogModes.NO );

// =======================================================
var id30 = charIDToTypeID( "setd" );
    var desc6 = new ActionDescriptor();
    var id31 = charIDToTypeID( "null" );
        var ref3 = new ActionReference();
        var id32 = charIDToTypeID( "Chnl" );
        var id33 = charIDToTypeID( "fsel" );
        ref3.putProperty( id32, id33 );
    desc6.putReference( id31, ref3 );
    var id34 = charIDToTypeID( "T   " );
        var desc7 = new ActionDescriptor();
        var id35 = charIDToTypeID( "Pts " );
            var list1 = new ActionList();
                var desc8 = new ActionDescriptor();
                var id36 = charIDToTypeID( "Hrzn" );
                var id37 = charIDToTypeID( "#Pxl" );
                desc8.putUnitDouble( id36, id37, 22.600000 );
                var id38 = charIDToTypeID( "Vrtc" );
                var id39 = charIDToTypeID( "#Pxl" );
                desc8.putUnitDouble( id38, id39, 24.600000 );
            var id40 = charIDToTypeID( "Pnt " );
            list1.putObject( id40, desc8 );
                var desc9 = new ActionDescriptor();
                var id41 = charIDToTypeID( "Hrzn" );
                var id42 = charIDToTypeID( "#Pxl" );
                desc9.putUnitDouble( id41, id42, 28.000000 );
                var id43 = charIDToTypeID( "Vrtc" );
                var id44 = charIDToTypeID( "#Pxl" );
                desc9.putUnitDouble( id43, id44, 24.400000 );
            var id45 = charIDToTypeID( "Pnt " );
            list1.putObject( id45, desc9 );
                var desc10 = new ActionDescriptor();
                var id46 = charIDToTypeID( "Hrzn" );
                var id47 = charIDToTypeID( "#Pxl" );
                desc10.putUnitDouble( id46, id47, 25.200000 );
                var id48 = charIDToTypeID( "Vrtc" );
                var id49 = charIDToTypeID( "#Pxl" );
                desc10.putUnitDouble( id48, id49, 49.200000 );
            var id50 = charIDToTypeID( "Pnt " );
            list1.putObject( id50, desc10 );
                var desc11 = new ActionDescriptor();
                var id51 = charIDToTypeID( "Hrzn" );
                var id52 = charIDToTypeID( "#Pxl" );
                desc11.putUnitDouble( id51, id52, 22.600000 );
                var id53 = charIDToTypeID( "Vrtc" );
                var id54 = charIDToTypeID( "#Pxl" );
                desc11.putUnitDouble( id53, id54, 24.200000 );
            var id55 = charIDToTypeID( "Pnt " );
            list1.putObject( id55, desc11 );
        desc7.putList( id35, list1 );
    var id56 = charIDToTypeID( "Plgn" );
    desc6.putObject( id34, id56, desc7 );
    var id57 = charIDToTypeID( "AntA" );
    desc6.putBoolean( id57, true );
executeAction( id30, desc6, DialogModes.NO );


dcmnt.selection.translateBoundary((50*iclc), 1);
dcmnt.selection.rotateBoundary(i, AnchorPosition.TOPCENTER);

dcmnt.activeLayer = lyr4[iclc];
dcmnt.selection.fill(hndFill);
dcmnt.activeLayer = lyr1[iclc];
dcmnt.selection.fill(fill3);
dcmnt.activeLayer = lyrmask[iclc];
dcmnt.selection.clear();
dcmnt.selection.translateBoundary(0, 50);
dcmnt.selection.fill(mskFill2);			
}
// =======================================================

dcmnt.flatten()

var svFile = new File(fldrPth);
 
var id1 = charIDToTypeID( "save" );
    var desc1 = new ActionDescriptor();
    var id2 = charIDToTypeID( "As  " );
        var desc2 = new ActionDescriptor();
        var id3 = charIDToTypeID( "Rslt" );
        var id4 = charIDToTypeID( "DpDp" );
        var id5 = charIDToTypeID( "32Bt" );
        desc2.putEnumerated( id3, id4, id5 );
        var id6 = charIDToTypeID( "JPEQ" );
        var id7 = charIDToTypeID( "Qlty" );
        var id8 = charIDToTypeID( "Mdm " );
        desc2.putEnumerated( id6, id7, id8 );
    var id9 = charIDToTypeID( "PICF" );
    desc1.putObject( id2, id9, desc2 );
    var id10 = charIDToTypeID( "In  " );
    desc1.putPath( id10, svFile );
    var id11 = charIDToTypeID( "Extn" );
    desc1.putBoolean( id11, true );
executeAction( id1, desc1, DialogModes.NO );

 
dcmnt.close(SaveOptions.DONOTSAVECHANGES);

}

/* ------borrowed function(from scriptlistener) for circular marquee selection------ */
function circularSelection(l, t, r, b)
{
	var id18 = charIDToTypeID("setd");
	var desc3 = new ActionDescriptor();
	var id19 = charIDToTypeID("null");
	var ref1 = new ActionReference();
	var id20 = charIDToTypeID("Chnl");
	var id21 = charIDToTypeID("fsel");
	ref1.putProperty(id20, id21);
	desc3.putReference(id19, ref1);
	var id22 = charIDToTypeID("T   ");
	var desc4 = new ActionDescriptor();
	var id23 = charIDToTypeID("Top ");
	var id24 = charIDToTypeID("#Pxl");
	desc4.putUnitDouble(id23, id24, t);
	var id25 = charIDToTypeID("Left");
	var id26 = charIDToTypeID("#Pxl");
	desc4.putUnitDouble(id25, id26, l);
	var id27 = charIDToTypeID("Btom");
	var id28 = charIDToTypeID("#Pxl");
	desc4.putUnitDouble(id27, id28, b);
	var id29 = charIDToTypeID("Rght");
	var id30 = charIDToTypeID("#Pxl");
	desc4.putUnitDouble(id29, id30, r);
	var id31 = charIDToTypeID("Elps");
	desc3.putObject(id22, id31, desc4);
	var id32 = charIDToTypeID("Fthr");
	var id33 = charIDToTypeID("#Pxl");
	desc3.putUnitDouble(id32, id33, 0);
	var id34 = charIDToTypeID("AntA");
	desc3.putBoolean(id34, 1);
	executeAction(id18, desc3, DialogModes.NO);
}


/* ------Ending Deinitialization------ */
app.preferences.rulerUnits = startRulerUnits;
app.preferences.typeUnits = startTypeUnits;
app.displayDialogs = startDisplayDialogs;